unit DD71u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

const ver='12june07..w/ edit by Textpad';
  kBitMapWidth=300;
  kBitMapHeight=200;

type
  TDD71f1 = class(TForm)
    Image1: TImage;
    buDoIt: TButton;
    buQuit: TButton;
    eYHi: TEdit;
    eYLo: TEdit;
    eXlo: TEdit;
    eXHi: TEdit;
    eA: TEdit;
    eB: TEdit;
    eC: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure buDoItClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buClearMsgClick(Sender: TObject);
  private
    { Private declarations }
    rScaleX, rScaleY:real;
    iXLo, iXHi, iYLo, iYHi:integer;
    function siEditToFloat(sTmp:string):single;
    function iScaleX(rTmp:real):integer;
    function iScaleAndClipY(rTmp:real):integer;
  public
    { Public declarations }
  end;

var
  DD71f1: TDD71f1;

implementation

uses DD71uErrMsg;

{$R *.DFM}

procedure TDD71f1.FormCreate(Sender: TObject);
var Bitmap:TBitmap;(*Provide a suitable variable*)
begin(*main of OnCreate*)
Bitmap:=TBitmap.create;(*Create a bitmap object*)
Bitmap.width:=kBitMapWidth;(*Assign dimensions*)
Bitmap.height:=kBitMapHeight;
Image1.Picture.Graphic:=Bitmap;(*Assign the bitmap to the image component*)
Image1.width:=kBitMapWidth;
Image1.height:=kBitMapHeight;
iXLo:=round(siEditToFloat(eXLo.text));
iXHi:=round(siEditToFloat(eXHi.text));
iYLo:=round(siEditToFloat(eYLo.text));
iYHi:=round(siEditToFloat(eYHi.text));
rScaleX:=kBitMapWidth/round(siEditToFloat(eXHi.text)-
   siEditToFloat(eXLo.text));
rScaleY:=kBitMapHeight/round(siEditToFloat(eYHi.text)-
  siEditToFloat(eYLo.text));
   (*Have a look at the canvas Help to see all the properties*)
end;

procedure TDD71f1.buDoItClick(Sender: TObject);
var si1, si2, si3, siA, siB, siC, siY, siTestsPassed:single;
sTmp:string;
begin
siTestsPassed:=0;

iXLo:=round(siEditToFloat(eXLo.text));
iXHi:=round(siEditToFloat(eXHi.text));
rScaleX:=kBitMapWidth/round(siEditToFloat(eXHi.text)-
   siEditToFloat(eXLo.text));

iYLo:=round(siEditToFloat(eYLo.text));
iYHi:=round(siEditToFloat(eYHi.text));
rScaleY:=kBitMapHeight/round(siEditToFloat(eYHi.text)-
  siEditToFloat(eYLo.text));

si1:=siEditToFloat(eXLo.text);
si2:=siEditToFloat(eXHi.text);
si3:=(si2-si1)/200;//The divisor determines how many steps
   //there will be across graph.
siA:=siEditToFloat(eA.Text);
siB:=siEditToFloat(eB.Text);
siC:=siEditToFloat(eC.text);

if iXLo=999999 then siTestsPassed:=1;
if iXHi=999999 then siTestsPassed:=2;
if iYLo=999999 then siTestsPassed:=3;
if iYHi=999999 then siTestsPassed:=4;
if siA=999999 then siTestsPassed:=5;
if siB=999999 then siTestsPassed:=6;
if siC=999999 then siTestsPassed:=7;
//add test for if iXLo>=iXHi, if iYLo>=iYHi, and messges for same.
if siTestsPassed=0 then begin

with Image1.Picture.Bitmap.canvas do begin
  repeat
    siY:=(si1-siB)*(si1-siB)*-1;
    siY:=exp(siY);
    siY:=(siA*siY)+siC;

    pixels[iScaleX(si1),
       iScaleAndClipY(siY)]:=clBlue;
    si1:=si1+si3;
  until si1>si2;
end;//with
end // no ; here
else begin
sTmp:='unexpected error code';
case round(siTestsPassed) of
1:sTmp:='Problem is in the low value for the X axis';
2:sTmp:='Problem is in the high value for the X axis';
3:sTmp:='Problem is in the low value for the Y axis';
4:sTmp:='Problem is in the high value for the Y axis';
5:sTmp:='Problem is in the value for the first constant';
6:sTmp:='Problem is in the value for the second constant';
7:sTmp:='Problem is in the value for the third constant';
//add messages for if iXLo>=iXHi, if iYLo>=iYHi
end;//case
DD71ErrMsgF.visible:=true;
DD71ErrMsgF.laErr.caption:=sTmp;

end; //else

end; //buDoItClick

procedure TDD71f1.buQuitClick(Sender: TObject);
begin
close;
end;

function TDD71f1.siEditToFloat(sTmp:string):single;
var siTmp:single;
begin
try
siTmp:=strtofloat(sTmp);
except
on EConvertError do siTmp:=999999;
//999999: rogue value to say "Could not convert".
end;
result:=siTmp;
end;

function TDD71f1.iScaleX(rTmp:real):integer;
begin
result:=trunc((rTmp-siEditToFloat(eXLo.text))*rScaleX);
end;

function TDD71f1.iScaleAndClipY(rTmp:real):integer;
//The many calls to eXLo, etc, in this could be replaced
//by value held in more convenient places, places that would
//only need updating if the contents of the edit boxes changed.
var iTmp:integer;
begin
 iTmp:=kBitMapHeight-round((rTmp-siEditToFloat(eYLo.text))*rScaleY);
 if iTmp> kBitMapHeight
   then iTmp:= kBitMapHeight;
 if iTmp< 0
   then iTmp:=0;
result:=iTmp;
end;

procedure TDD71f1.buClearMsgClick(Sender: TObject);
begin
DD71ErrMsgF.visible:=false;
end;

end.
